> ## Documentation Index
> Fetch the complete documentation index at: https://docs.tight.com/llms.txt
> Use this file to discover all available pages before exploring further.

# Save customers

> Save new (or update existing) customers



## OpenAPI

````yaml https://dev.tight.com/v3/api-docs post /v6/customers
openapi: 3.0.1
info:
  title: Tight API
  contact:
    name: Hurdlr, Inc. (dba Tight)
    url: https://www.tight.com
    email: api@tight.com
  version: 6.0.0
servers:
  - url: https://sandbox.tight.com
    description: Staging Environment
  - url: https://prod.tight.com
    description: Production Environment
security:
  - EmbedToken: []
paths:
  /v6/customers:
    post:
      tags:
        - Customers
      summary: Save customers
      description: Save new (or update existing) customers
      operationId: postCustomers
      requestBody:
        content:
          application/json:
            schema:
              $ref: '#/components/schemas/MultiParamCustomerPostDto'
        required: true
      responses:
        '200':
          description: Success
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/ResponseListMultiResponseCustomerGetDto'
        '207':
          description: Some customers failed to save. See response body for error details.
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/ResponseListMultiResponseCustomerGetDto'
        '400':
          description: All customers failed to save.
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/ResponseListMultiResponseCustomerGetDto'
        '401':
          description: Not authenticated
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/ErrorResponse'
              example:
                result: FAILURE
                error:
                  - type: INVALID_TOKEN
                    message: Invalid access token
        '403':
          description: Not authorized
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/ErrorResponse'
              example:
                result: FAILURE
                error:
                  - type: FORBIDDEN
                    message: Expired access token
        '404':
          description: Endpoint not found
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/ErrorResponse'
              example:
                result: FAILURE
                error:
                  - type: BAD_REQUEST
                    message: Resource not found
        '500':
          description: Internal server error
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/ErrorResponse'
              example:
                result: FAILURE
                error:
                  - type: UNKNOWN_ERROR
                    message: Something went wrong. Please try again later.
      security:
        - EmbedToken: []
components:
  schemas:
    MultiParamCustomerPostDto:
      required:
        - data
      type: object
      properties:
        data:
          type: array
          items:
            $ref: '#/components/schemas/CustomerPostDto'
    ResponseListMultiResponseCustomerGetDto:
      type: object
      properties:
        result:
          type: string
          description: The result of the action performed.
          enum:
            - SUCCESS
            - FAILURE
        data:
          type: array
          description: The data generated by the action performed.
          items:
            $ref: '#/components/schemas/MultiResponseCustomerGetDto'
        error:
          type: array
          items:
            $ref: '#/components/schemas/ErrorItem'
    ErrorResponse:
      type: object
      properties:
        result:
          type: string
          description: The result of the action performed.
          enum:
            - SUCCESS
            - FAILURE
        data:
          type: object
          description: The data generated by the action performed.
          nullable: true
        error:
          type: array
          items:
            $ref: '#/components/schemas/ErrorItem'
    CustomerPostDto:
      required:
        - name
      type: object
      properties:
        id:
          type: string
          description: Id of the customer, required when updating an existing customer
          example: cus_28868401
        name:
          type: string
          description: Name of the customer
          nullable: false
          example: Acme Corp
        status:
          type: string
          description: Status of the customer
          nullable: false
          example: ACTIVE
          enum:
            - ACTIVE
            - INACTIVE
            - REMOVED
        additionalContactName:
          type: string
          description: Name of an additional contact for this customer
          nullable: false
          example: Jane Smith
        businessName:
          type: string
          description: Business name of the customer
          nullable: false
          example: Acme Corporation LLC
        email:
          type: string
          description: Email address of the customer
          nullable: false
          example: billing@acme.com
        ccEmails:
          type: array
          nullable: false
          items:
            type: string
            description: CC email addresses for invoices sent to this customer
            example: '["cc@acme.com"]'
        bccEmails:
          type: array
          nullable: false
          items:
            type: string
            description: BCC email addresses for invoices sent to this customer
            example: '["bcc@acme.com"]'
        invoiceSettings:
          $ref: '#/components/schemas/CustomerInvoiceSettingsPostDto'
        address:
          $ref: '#/components/schemas/AddressPostDto'
        customData:
          $ref: '#/components/schemas/JsonNode'
    MultiResponseCustomerGetDto:
      type: object
      properties:
        result:
          type: string
          description: The result of the action performed.
          enum:
            - SUCCESS
            - FAILURE
        statusCode:
          $ref: '#/components/schemas/HttpStatus'
        data:
          $ref: '#/components/schemas/CustomerGetDto'
        error:
          type: array
          items:
            $ref: '#/components/schemas/ErrorItem'
      description: The data generated by the action performed.
    ErrorItem:
      type: object
      properties:
        type:
          type: string
          description: The type of the error. Safe for programmatic use.
          enum:
            - UNKNOWN_ERROR
            - INVALID_TOKEN
            - EXPIRED_TOKEN
            - FORBIDDEN
            - BAD_REQUEST
            - JSON_ERROR
            - DUPLICATE
            - REQUIRED
            - INVALID_VALUE
            - NOT_MODIFIABLE
            - INVALID_FORMAT
            - NOT_FOUND
        message:
          type: string
          description: >-
            A human-readable message providing more details about the error.
            Safe for displaying to a user.
        param:
          type: string
          description: >-
            If the error is parameter-specific, the parameter related to the
            error. This can be used to display a message near the correct form
            field.
      description: Errors associated with the action performed, if applicable.
    CustomerInvoiceSettingsPostDto:
      type: object
      properties:
        invoicePrefix:
          type: string
          description: Prefix used for invoice numbers for this customer
          nullable: false
          example: INV-
        showAdditionalContactName:
          type: boolean
          description: Whether to show the additional contact name on invoices
          nullable: false
          example: true
        showBusinessName:
          type: boolean
          description: Whether to show the business name on invoices
          nullable: false
          example: true
        showName:
          type: boolean
          description: Whether to show the customer name on invoices
          nullable: false
          example: true
        showEmail:
          type: boolean
          description: Whether to show the customer email on invoices
          nullable: false
          example: true
        showAddress:
          type: boolean
          description: Whether to show the customer address on invoices
          nullable: false
          example: true
        showPhoneWork:
          type: boolean
          description: Whether to show the work phone number on invoices
          nullable: false
          example: true
      description: Invoice display settings for this customer
      nullable: false
    AddressPostDto:
      type: object
      properties:
        state:
          type: string
          description: State/Province of the address
          nullable: false
        city:
          type: string
          description: City of the address
          nullable: false
        zip:
          type: string
          description: Zip/Postal code of the address
          nullable: false
        phoneWork:
          type: string
          description: The US/CA phone number in E.164 format (e.g., +14155551234)
          nullable: false
        address1:
          type: string
          description: First line of the address
          nullable: false
        address2:
          type: string
          description: Second line of the address
          nullable: false
      description: Address of the vendor
      nullable: false
    JsonNode:
      type: object
      properties:
        empty:
          type: boolean
        array:
          type: boolean
        'null':
          type: boolean
        object:
          type: boolean
        float:
          type: boolean
        string:
          type: boolean
        number:
          type: boolean
        missingNode:
          type: boolean
        valueNode:
          type: boolean
        nodeType:
          type: string
          enum:
            - ARRAY
            - BINARY
            - BOOLEAN
            - MISSING
            - 'NULL'
            - NUMBER
            - OBJECT
            - POJO
            - STRING
        pojo:
          type: boolean
        integralNumber:
          type: boolean
        floatingPointNumber:
          type: boolean
        short:
          type: boolean
        int:
          type: boolean
        long:
          type: boolean
        double:
          type: boolean
        bigDecimal:
          type: boolean
        bigInteger:
          type: boolean
        textual:
          type: boolean
          deprecated: true
        boolean:
          type: boolean
        binary:
          type: boolean
        container:
          type: boolean
        embeddedValue:
          type: boolean
      description: >-
        Custom JSON in which you can store any data with max length of 2000
        characters
      nullable: true
      example:
        internal_key: some_internal_key
        some_other_field: 23434
    HttpStatus:
      type: integer
      description: The HTTP status code for the action performed.
      format: int32
      enum:
        - 200
        - 400
        - 401
        - 403
        - 404
        - 500
    CustomerGetDto:
      required:
        - additionalContactName
        - address
        - bccEmails
        - businessName
        - ccEmails
        - email
        - id
        - invoiceSettings
        - name
        - status
      type: object
      properties:
        id:
          type: string
          description: Id of the customer
          example: cus_28868401
        name:
          type: string
          description: Name of the customer
          example: Acme Corp
        status:
          type: string
          description: Status of the customer
          example: ACTIVE
          enum:
            - ACTIVE
            - INACTIVE
            - REMOVED
        additionalContactName:
          type: string
          description: Name of an additional contact for this customer
          nullable: true
          example: Jane Smith
        businessName:
          type: string
          description: Business name of the customer
          nullable: true
          example: Acme Corporation LLC
        email:
          type: string
          description: Email address of the customer
          nullable: true
          example: billing@acme.com
        ccEmails:
          type: array
          description: CC email addresses for invoices sent to this customer
          example:
            - cc@acme.com
          items:
            type: string
            description: CC email addresses for invoices sent to this customer
            example: '["cc@acme.com"]'
        bccEmails:
          type: array
          description: BCC email addresses for invoices sent to this customer
          example:
            - bcc@acme.com
          items:
            type: string
            description: BCC email addresses for invoices sent to this customer
            example: '["bcc@acme.com"]'
        invoiceSettings:
          $ref: '#/components/schemas/CustomerInvoiceSettingsGetDto'
        address:
          $ref: '#/components/schemas/AddressGetDto'
        customData:
          $ref: '#/components/schemas/JsonNode'
      description: The data generated by the action performed.
    CustomerInvoiceSettingsGetDto:
      required:
        - invoicePrefix
        - showAdditionalContactName
        - showAddress
        - showBusinessName
        - showEmail
        - showName
        - showPhoneWork
      type: object
      properties:
        invoicePrefix:
          type: string
          description: Prefix used for invoice numbers for this customer
          nullable: true
          example: INV-
        showAdditionalContactName:
          type: boolean
          description: Whether to show the additional contact name on invoices
          example: true
        showBusinessName:
          type: boolean
          description: Whether to show the business name on invoices
          example: true
        showName:
          type: boolean
          description: Whether to show the customer name on invoices
          example: true
        showEmail:
          type: boolean
          description: Whether to show the customer email on invoices
          example: true
        showAddress:
          type: boolean
          description: Whether to show the customer address on invoices
          example: true
        showPhoneWork:
          type: boolean
          description: Whether to show the work phone number on invoices
          example: true
      description: Invoice display settings for this customer
    AddressGetDto:
      type: object
      properties:
        countryCode:
          type: string
          description: Country Code of the address
          example: USA
          enum:
            - USA
            - CAN
            - GBR
        state:
          type: string
          description: State/Province of the address
        city:
          type: string
          description: City of the address
        zip:
          type: string
          description: Zip/Postal code of the address
        phoneWork:
          type: string
          description: The phone number
        address1:
          type: string
          description: First line of the address
        address2:
          type: string
          description: Second line of the address
      description: Address of the vendor
      nullable: true
  securitySchemes:
    EmbedToken:
      type: http
      description: >-
        Bearer authentication header of the form `Bearer <token>`, see
        [Authentication for more
        detail](/api-reference/authentication#partner-level-authentication).
      scheme: bearer

````